/******************************************************************************
*******************************************************************************
*******************************************************************************

    fcat
    Copyright (C) 2002 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: ChildStreamServer.hh,v 1.2 2007/12/11 21:30:12 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#ifndef _ALREADY_INCLUDED_FERRIS_CHILD_STREAM_SERV_H_
#define _ALREADY_INCLUDED_FERRIS_CHILD_STREAM_SERV_H_

#include <Ferris/HiddenSymbolSupport.hh>

#include <list>
#include <string>

#include <Ferris/Ferris.hh>
#include <Ferris/Runner.hh>

#include <Functor.h>

namespace Ferris
{
    class ChildStreamServer;
    FERRIS_SMARTPTR( ChildStreamServer, fh_childserv );

    class FERRISEXP_API ChildStreamServer
        :
        public Handlable
    {
        typedef std::list< fh_runner > children_t;
        children_t m_children;

        static guint   s_childWatcherID;
        static guint32 s_childWatcherInterval;

    public:

        ChildStreamServer();
        ~ChildStreamServer();
        
        void addChild( fh_runner r );

        typedef Loki::Functor< void,
                               LOKI_TYPELIST_3( fh_childserv,
                                                fh_runner,
                                                int /* exit status */ ) > ChildDiedFunctor_t;
        typedef std::list< ChildDiedFunctor_t > ChildDiedFunctors_t;
        ChildDiedFunctors_t m_ChildDiedFunctors;
        void addDiedFunctor( ChildDiedFunctor_t f );
        void clearDiedFunctors();

        
        // private
        gint childHasDied( pid_t pid, int status );
    };
    
};

#endif
