/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: FerrisDevContext_private.hh,v 1.1 2005/07/04 08:59:32 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#ifndef _ALREADY_INCLUDED_FERRIS_DEV_CONTEXT_PRIVH_
#define _ALREADY_INCLUDED_FERRIS_DEV_CONTEXT_PRIVH_

#include <Ferris/HiddenSymbolSupport.hh>
#include <Ferris/Ferris.hh>

namespace Ferris
{
    /**
     * Root context for ferrisdev://
     */
    class FERRISEXP_DLLLOCAL FerrisDevRootContext
        :
        public StateLessEAHolder< FerrisDevRootContext, FakeInternalContext >
    {
        typedef FerrisDevRootContext                                           _Self;
        typedef StateLessEAHolder< FerrisDevRootContext, FakeInternalContext > _Base;
        
        virtual void priv_FillCreateSubContextSchemaParts( CreateSubContextSchemaPart_t& m );

        
    protected:

        virtual void priv_read();
        
    public:

        FerrisDevRootContext();
        virtual ~FerrisDevRootContext();

        void createStateLessAttributes( bool force = false );

        
    };

    /**
     *
     * Generates a unique ID either based on a overflowing 64bit integer
     * or a uuid depending on which file is read.
     *
     */
    class FERRISEXP_DLLLOCAL FerrisDevGeneratorContext
        :
        public StateLessEAHolder< FerrisDevGeneratorContext, leafContext >
    {
        friend class FerrisDevRootContext;
        
        typedef FerrisDevGeneratorContext                                   _Self;
        typedef StateLessEAHolder< FerrisDevGeneratorContext, leafContext > _Base;
        
    protected:

    public:

        FerrisDevGeneratorContext( Context* parent, const char* rdn );
        virtual ~FerrisDevGeneratorContext();

        void createStateLessAttributes( bool force = false );

    };

    extern std::string exstr_64;
    extern std::string exstr_32;
    
    
};
#endif
