/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: FerrisEAGeneratorPlugin.hh,v 1.2 2006/03/16 00:40:36 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#ifndef _ALREADY_INCLUDED_FERRIS_EAGEN_PLUGIN_H_
#define _ALREADY_INCLUDED_FERRIS_EAGEN_PLUGIN_H_

#include <Ferris/HiddenSymbolSupport.hh>
#include <Ferris/Ferris.hh>
#include <Ferris/MatchedEAGenerators.hh>

namespace Ferris
{
    /**
     * EA generator plugins are now (1.1.10)+ able to have their
     * factory module bootstrapped statically to libferris.so
     *
     * @ma the matcher to tell if this plugin is interested in making attributes
     * @implname Name of the main shared library for plugin
     * @shortname User presentable one word description
     * @isDynamic
     * @hasState
     * @CreatePri
     *
     */ 
    FERRISEXP_API bool RegisterEAGeneratorModule(
        const fh_matcher& ma,
        const std::string& implname,
        const std::string& shortname,
        bool isDynamic = false,
        bool hasState = false,
        AttributeCreator::CreatePri_t CreatePri =
        AttributeCreator::CREATE_PRI_NOT_SUPPORTED
        );
    
    
};

#endif
