/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: FerrisEvent.cpp,v 1.1 2005/07/04 08:56:42 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#include <FerrisEvent.hh>
#include <Ferris.hh>

namespace Ferris
{
    

    void NamingEvent::setSource( fh_context s ) 
    {
        source = s;
    }
    
    NamingEvent::NamingEvent( fh_context _s, SigC::Object* _uobj )
        :
        source(_s),
        uobj(_uobj)
    {
    }
    
    fh_context
    NamingEvent::getSource() 
    {
        return source;
    }
    

    /********************************************************************************/
    /********************************************************************************/
    /********************************************************************************/

    NamingEvent_Changed::NamingEvent_Changed( fh_context _s, SigC::Object* _uobj )
        :
        NamingEvent( _s, _uobj )
    {
    }
    

    NamingEvent_Deleted::NamingEvent_Deleted( fh_context _s, SigC::Object* _uobj )
        :
        NamingEvent( _s, _uobj )
    {
    }
    

    NamingEvent_Start_Execute::NamingEvent_Start_Execute( fh_context _s, SigC::Object* _uobj )
        :
        NamingEvent( _s, _uobj )
    {
    }

    NamingEvent_Stop_Execute::NamingEvent_Stop_Execute( fh_context _s, SigC::Object* _uobj )
        :
        NamingEvent( _s, _uobj )
    {
    }

    NamingEvent_Created::NamingEvent_Created( fh_context _s, SigC::Object* _uobj )
        :
        NamingEvent( _s, _uobj )
    {
    }

    NamingEvent_Moved::NamingEvent_Moved( fh_context _s, SigC::Object* _uobj )
        :
        NamingEvent( _s, _uobj )
    {
    }


    NamingEvent_Exists::NamingEvent_Exists( fh_context _s, SigC::Object* _uobj )
        :
        NamingEvent( _s, _uobj )
    {
    }

    NamingEvent_Start_Reading_Context::NamingEvent_Start_Reading_Context( fh_context _s, SigC::Object* _uobj )
        :
        NamingEvent( _s, _uobj )
    {
    }

    NamingEvent_Stop_Reading_Context::NamingEvent_Stop_Reading_Context( fh_context _s, SigC::Object* _uobj )
        :
        NamingEvent( _s, _uobj )
    {
    }

    
};
