/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: FerrisEvent.hh,v 1.1 2005/07/04 08:59:32 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#ifndef _ALREADY_INCLUDED_FERRIS_EVENT_H_
#define _ALREADY_INCLUDED_FERRIS_EVENT_H_

#include <Ferris/HiddenSymbolSupport.hh>
#include <Ferris/TypeDecl.hh>

namespace Ferris
{
    
    class FERRISEXP_API NamingEvent
    {
        fh_context source;
        SigC::Object* uobj;
        
    protected:

        void setSource( fh_context s );
    
    public:
    
        NamingEvent( fh_context _s, SigC::Object* _uobj );
        fh_context getSource();
    };

    class FERRISEXP_API NamingEvent_Changed : public NamingEvent
    {
    public:
        NamingEvent_Changed( fh_context _s, SigC::Object* _uobj );
    };

    class FERRISEXP_API NamingEvent_Deleted : public NamingEvent
    {
    public:
        NamingEvent_Deleted( fh_context _s, SigC::Object* _uobj );
    };

    class FERRISEXP_API NamingEvent_Start_Execute : public NamingEvent
    {
    public:
        NamingEvent_Start_Execute( fh_context _s, SigC::Object* _uobj );
    };

    class FERRISEXP_API NamingEvent_Stop_Execute : public NamingEvent
    {
    public:
        NamingEvent_Stop_Execute( fh_context _s, SigC::Object* _uobj );
    };
    
    class FERRISEXP_API NamingEvent_Created : public NamingEvent
    {
    public:
        NamingEvent_Created( fh_context _s, SigC::Object* _uobj );
    };

    class FERRISEXP_API NamingEvent_Moved : public NamingEvent
    {
    public:
        NamingEvent_Moved( fh_context _s, SigC::Object* _uobj );
    };
    
    class FERRISEXP_API NamingEvent_Exists : public NamingEvent
    {
    public:
        NamingEvent_Exists( fh_context _s, SigC::Object* _uobj );
    };
    
    class FERRISEXP_API NamingEvent_Start_Reading_Context : public NamingEvent
    {
    public:
        NamingEvent_Start_Reading_Context( fh_context _s, SigC::Object* _uobj );
    };

    class FERRISEXP_API NamingEvent_Stop_Reading_Context : public NamingEvent
    {
    public:
        NamingEvent_Stop_Reading_Context( fh_context _s, SigC::Object* _uobj );
    };

};
#endif
