/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: LinkContextScheme.hh,v 1.2 2006/12/07 06:44:05 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#ifndef _ALREADY_INCLUDED_LINK_CONTEXT_SCHEME_H_
#define _ALREADY_INCLUDED_LINK_CONTEXT_SCHEME_H_

#include <Ferris/HiddenSymbolSupport.hh>
#include <Ferris/Resolver.hh>
#include <Ferris/Resolver_private.hh>

namespace Ferris
{

    template <const std::string& name, const std::string& earl >
    class LinkContextSchemeVFS_RootContextDropper
        :
        public RootContextDropper
    {
    public:
        
        LinkContextSchemeVFS_RootContextDropper()
            {
                ImplementationDetail::appendToStaticLinkedRootContextNames( name );
                RootContextFactory::Register( name, this );
            }

        fh_context Brew( RootContextFactory* rf )
            throw( RootContextCreationFailed )
            {
//                 cerr << "LinkContextSchemeVFS_RootContextDropper<1> name:" << name
//                      << " url:" << earl << endl;
//                 DEBUG_dumpcl( "LinkContextSchemeVFS_RootContextDropper<1>" );

                try
                {
                    static fh_context c = Resolve( earl );
                    return c;
                }
                catch( std::exception& e )
                {
                    fh_stringstream ss;
                    ss << "ERROR: fundamental access scheme can not resolve." << std::endl
                       << "looking for earl:" << earl << std::endl
                       << " nested:" << e.what() << std::endl
                       << "Your libferris is not installed correctly." << std::endl;
                    std::cerr << tostr(ss) << std::endl;
                    Throw_RootContextCreationFailed( tostr(ss), 0 );
                }
            }
    };
 
};


#endif
