/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: Versioned.hh,v 1.1 2005/07/04 08:58:39 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#ifndef _ALREADY_INCLUDED_FERRIS_VERSIONED_H_
#define _ALREADY_INCLUDED_FERRIS_VERSIONED_H_

#include <Ferris/HiddenSymbolSupport.hh>
#include <Ferris/TypeDecl.hh>

namespace Ferris
{
    class FERRISEXP_API Versioned
        :
        public Handlable
    {
    public:
        
        typedef guint32 Version_t;

        Versioned();
        Version_t getVersion() const;

    protected:
        
        void bumpVersion();
        void setVersion( Version_t v );
    
    private:
        
        Version_t Version;
        static const Version_t MINIMUM_VERSION = 1;

    };
};
#endif
