/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: FerrisGCJ.cpp,v 1.1 2005/07/04 08:55:04 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#include <FerrisGCJ_private.hh>

namespace Ferris
{
    std::string tostr( jstring jstr )
    {
        jsize s = JvGetStringUTFLength ( jstr );
        std::string ret;
        ret.resize( s );
        JvGetStringUTFRegion( jstr, 0, s, (char*)ret.data() );
        return ret;
    }
    
    namespace Java
    {
        template <>
        ::java::lang::String* tojstr( const std::string& v )
        {
            return JvNewStringLatin1( v.c_str() );
        }
        template <>
        ::java::lang::String* tojstr( std::string v )
        {
            return JvNewStringLatin1( v.c_str() );
        }
        template <>
        ::java::lang::String* tojstr( const char* v )
        {
            return JvNewStringLatin1( v );
        }
    };
    namespace Factory
    {
        void ensureJVMCreated()
        {
            static bool v = true;

            if( v )
            {
                v = false;
                
                JvCreateJavaVM(NULL);
                JvAttachCurrentThread(NULL, NULL);
                JvInitClass(&System::class$);
            }
        }
    };
};
