/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: FerrisGCJ_private.hh,v 1.1 2005/07/04 08:55:04 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#ifndef _ALREADY_INCLUDED_FERRIS_GCJ_H_
#define _ALREADY_INCLUDED_FERRIS_GCJ_H_

#include <gcj/cni.h>
#include <java/lang/System.h>
#include <java/io/PrintStream.h>
#include <java/lang/Throwable.h>
#include <java/lang/Character.h>
#include <java/lang/StringBuffer.h>

#include <java/io/IOException.h>
#include <java/io/BufferedReader.h>
#include <java/io/InputStreamReader.h>

#include <FerrisStreams/All.hh>
#include <string>

namespace Ferris
{
    using namespace ::java::lang;

    std::string tostr( jstring jstr );
    
    namespace Java
    {
        template <class T>
        ::java::lang::String* tojstr( T v )
        {
            return tojstr( tostr( v ) );
        }
        template <>
        ::java::lang::String* tojstr( const std::string& v );
        template <>
        ::java::lang::String* tojstr( std::string v );
        template <>
        ::java::lang::String* tojstr( const char* v );
    };
    namespace Factory
    {
        void ensureJVMCreated();
    };
};

#endif
