#!/usr/bin/perl -w

#
# A little glue to open a context's lat/long point in a new firefox tab
#

$if=$ARGV[0];
$name=`basename $if`;

($long,$lat,$zoom,$emblemid) = split /,/,   `ferrisls -ld --show-ea=longitude,latitude,geospatial-range,geospatial-emblem-id --field-seperator=","  $if`;
$uid=`id -u`;
chomp $uid;
$tmpfile="/tmp/libferris-google-earth-glue-$uid.kml";

print "tmpfile:$tmpfile\n";
print "name:$if lat:$lat long:$long zoom:$zoom id:$uid emblemid:$emblemid\n";

if( $lat <= 0 || $long <= 0 ) 
  {
    print "No map location for this context:$if\n"
  }
else
  {
    print "ok\n";

    open(OSS,">$tmpfile");
    print OSS "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
    print OSS "<kml xmlns=\"http://earth.google.com/kml/2.1\">\n";
    print OSS "<Placemark>\n";
    print OSS "	<name>$name</name>\n";
    print OSS "      <description>\n";
    print OSS "<![CDATA[\n";
    print OSS "Search nearby (5km) for:\n";
    print OSS "<a href=\"LIBFERRIS-SEARCH-EMBLEM-BY-ID-RADIUS5 $emblemid\">files</a>,\n";
    print OSS "<a href=\"LIBFERRIS-SEARCH-EMBLEM-BY-ID-RADIUS5-IMAGE-ONLY $emblemid\">image files</a>,\n";
    print OSS "<a href=\"LIBFERRIS-SEARCH-EMBLEM-BY-ID-RADIUS5-VIDEO-ONLY $emblemid\">video files</a>.\n";
    print OSS "<br><hr>Search for\n";
    print OSS "<br><a href=\"LIBFERRIS-SEARCH-EMBLEM-BY-ID $emblemid\">files with emblem</a>\n";
    print OSS "<br><a href=\"LIBFERRIS-SEARCH-EMBLEM-BY-ID-IMAGE-ONLY $emblemid\">image files with emblem</a>\n";
    print OSS "<br><a href=\"LIBFERRIS-SEARCH-EMBLEM-BY-ID-VIDEO-ONLY $emblemid\">video files with emblem</a>\n";
    print OSS "<br><hr>Search near (15km) for\n";
    print OSS "<br><a href=\"LIBFERRIS-SEARCH-EMBLEM-BY-ID-RADIUS15 $emblemid\">files</a>\n";
    print OSS "<br><a href=\"LIBFERRIS-SEARCH-EMBLEM-BY-ID-RADIUS15-IMAGE-ONLY $emblemid\">image files</a>\n";
    print OSS "<br><a href=\"LIBFERRIS-SEARCH-EMBLEM-BY-ID-RADIUS15-VIDEO-ONLY $emblemid\">video files</a>\n";
    print OSS "<br><hr>Search around (50km) for\n";
    print OSS "<br><a href=\"LIBFERRIS-SEARCH-EMBLEM-BY-ID-RADIUS50 $emblemid\">files</a>\n";
    print OSS "<br><a href=\"LIBFERRIS-SEARCH-EMBLEM-BY-ID-RADIUS50-IMAGE-ONLY $emblemid\">image files</a>\n";
    print OSS "<br><a href=\"LIBFERRIS-SEARCH-EMBLEM-BY-ID-RADIUS50-VIDEO-ONLY $emblemid\">video files</a>\n";
    print OSS "]]></description>\n";
    print OSS "	<LookAt>\n";
    print OSS "         <longitude>$long</longitude>\n";
    print OSS "         <latitude>$lat</latitude>" ;
    print OSS "         <range>$zoom</range>" ;
    print OSS "	</LookAt>\n";
    print OSS "      <Point>\n";
    print OSS "         <coordinates>$long,$lat,0</coordinates>\n";
    print OSS "      </Point>\n";
    print OSS "</Placemark>\n";
    print OSS "</kml>\n";
    
    $cmd="libferris-googleearth $tmpfile";
    print "command: $cmd\n";
    exec $cmd
  }

