/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: libferrismpeg2_factory.cpp,v 1.2 2006/12/07 06:47:22 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#include <FerrisEAPlugin.hh>

using namespace std;
namespace Ferris
{
    

static Factory::EndingList EL()
{
    static Factory::EndingList r;
    static bool virgin = true;
    
    if( virgin )
    {
        virgin = false;
        
        r.push_back( make_pair( string("name"), string(".mpg") ));
        r.push_back( make_pair( string("name"), string(".mpeg") ));
        r.push_back( make_pair( string("name"), string(".vob") ));
    }
    
    return r;
}

    /**
     *
     * New method that allows the factory itself to be statically bound
     * to libferris but the plugin to be dynamically loaded. (1.1.10)+
     *
     */
    namespace 
    {
        static bool r = RegisterEAGeneratorModule(
             Factory::ComposeEndsWithMatcher( EL() ),
             AUTOTOOLS_CONFIG_LIBDIR + "/ferris/plugins/eagenerators/libferrismpeg2.so",
            "mpeg2",
            false,
            false,
            AttributeCreator::CREATE_PRI_MED );
    };



};
