#!/usr/bin/perl -w

$dbname=`cat ~/.ferris/rdfdb/ferris-db-name`;
$dbops=`cat ~/.ferris/rdfdb/ferris-db-options`;
$dbstorage=`cat ~/.ferris/rdfdb/ferris-storage-name`;
chomp($dbname);
chomp($dbops);
chomp($dbstorage);

$rdfproccmd="rdfproc -s $dbstorage -t \"$dbops\"  $dbname ";
print "$rdfproccmd\n";

while(<>)
  {
    $line = $_;

    if( $line =~ s/name:uuid value:\[(.*)\]/$1/g ) 
      {
	chomp($line);
	$uuidnode = $line;
      }
    if( $line =~ s/name:bnode value:\((.*)\)/$1/g ) 
      {
	chomp($line);
	$bnode = "_:$line";
      }
    # name:historynode value:[ferris-file-view-history]
    if( $line =~ s/name:historynode value:\[ferris-file-(.*)\-history]/$1/g ) 
      {
	chomp($line);
	$pred = "http://witme.sf.net/libferris.web/rdf/ferris-attr/ferris-file-$line-history";
      }

    if ( $uuidnode && $pred && $bnode ) {
#      print "got uuidnode:$uuidnode and bnode:$bnode\n";
      $bnode =~ s/\"/\\\"/g;
      $cmd = "$rdfproccmd add \"$uuidnode\" \"$pred\" \"$bnode\"";
      print "$cmd\n";
      system $cmd;
      $pred = 0;
      $uuidnode = 0;
      $bnode = 0;
    }
    
}
