
#include <Ferris/Medallion.hh>
#include <Ferris/Medallion_private.hh>

using namespace Ferris;
using namespace std;


string uss( fh_emblem em )
{
    stringstream ss;

    emblems_t upset = em->getUpset();
    for( emblems_t::iterator ci = upset.begin(); ci != upset.end(); ++ci )
    {
        ss << "," << (*ci)->getName();
    }
    return ss.str();
}


int main( int, char** )
{
    fh_etagere et = Factory::getEtagere();
    fh_emblem eaOrdering = private_getAttributeRootEmblem( et );
    fh_emblem eaOrderingEmblems = eaOrdering->obtainChild( "emblems" );
    fh_emblem eaOrderingSchemas = eaOrdering->obtainChild( "schemas" );

    int EAOrderingEmblemCount = 0;
    emblems_t eraselist;
    emblems_t el = et->getAllEmblems();
    for( emblems_t::iterator ei = el.begin(); ei != el.end(); ++ei )
    {
        fh_emblem e = *ei;

        (*ei)->forceUpdateTransitiveChildOfEAOrderingRootEmblem();
        
        if( starts_with( e->getName(), "emblem:emblem" )
            || starts_with( e->getName(), "schema:emblem" )
            || starts_with( e->getName(), "emblem:has-schema:" )
            || starts_with( e->getName(), "emblem:has-emblem:" )
            || starts_with( e->getName(), "emblem:schema:emblem:" )
            )
        {
            eraselist.push_back( e );
        }
        
        cerr << "e.id:" << e->getID()
             << " e.name:" << e->getName()
             << " e.isTC(EAOrderEmblem):" << (*ei)->isTransitiveChildOfEAOrderingRootEmblem()
//             << " uss:" << uss( *ei )
             << endl;

        if( (*ei)->isTransitiveChildOfEAOrderingRootEmblem() )
            ++EAOrderingEmblemCount;
        
//         if( starts_with( e->getName(), "schema:emblem:schema" )
//             || starts_with( e->getName(), "emblem:schema:emblem" ) )
//         {
//             eraselist.push_back( e );
//         }
        if( starts_with( e->getName(), "emblem:" ))
        {
            emblems_t pl = e->getParents();
            if( pl.end() == find( pl.begin(), pl.end(), eaOrderingEmblems ) )
            {
                cerr << "moving e to emblems suborder:" << e->getName() << endl;
                unlink( eaOrdering, e );
                link( eaOrderingEmblems, e );
            }
        }
        else if( starts_with( e->getName(), "schema:" ))
        {
            emblems_t pl = e->getParents();
            if( pl.end() == find( pl.begin(), pl.end(), eaOrderingSchemas ) )
            {
                unlink( eaOrdering, e );
                link( eaOrderingSchemas, e );
            }
        }
        (*ei)->getUniqueName();
        (*ei)->isTransitiveChildOfEAOrderingRootEmblem();
    }


    cerr << "eraselist.sz:" << eraselist.size() << endl;
    for( emblems_t::iterator ei = eraselist.begin(); ei != eraselist.end(); )
    {
        fh_emblem e = *ei;
        ++ei;
        cerr << "erase emblem id:" << e->getID() << " name:" << e->getName() << endl;
        et->erase( e );
    }

    cerr << "EAOrderingEmblemCount:" << EAOrderingEmblemCount << endl;
    

    el = et->getAllEmblems();
    for( emblems_t::iterator ei = el.begin(); ei != el.end(); ++ei )
    {
        fh_emblem outeremblem = *ei;
        fh_emblem e = *ei;
//         const emblems_t& cl = e->getChildren();

//         for( emblems_t::const_iterator ci = cl.begin(); ci != cl.end(); ++ci )
//         {
//             fh_emblem e = *ci;
//             if( !e )
//                 cerr << "Found a null emblem in children of emblem:" << outeremblem->getName() << endl;
//         }

        cerr << "Force updates for e:" << e->getID() << endl;
        e->forceUpdateParentsAndChildrenIDs();
//        e->getDownset();
    }

    et->sync();
    
    return 0;
}
