/******************************************************************************
*******************************************************************************
*******************************************************************************

    libferris
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: libferrissqlplusshared.cpp,v 1.1 2005/07/12 04:03:31 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#include <Ferris.hh>
#include <Ferris_private.hh>
#include <Trimming.hh>
#include <sqlplus.hh>
#include <libferrissqlplusshared.hh>

using namespace std;

#define DBNAME FDB_SECURE


namespace Ferris
{
    typedef pair<string,string> userpass_t;
    
    userpass_t getUserPass( string serv )
    {
        string user;
        string pass;
        
        {
            fh_stringstream ss;
            ss << "mysql-server-" << serv << "-username";
            user = getEDBString( DBNAME, tostr(ss), "" );
        }
        
        {
            fh_stringstream ss;
            ss << "mysql-server-" << serv << "-password";
            pass = getEDBString( DBNAME, tostr(ss), "" );
        }

        return make_pair( user, pass );
    }


    void setUserPass( string serv, const std::string& user, const std::string& pass )
    {
        {
            fh_stringstream ss;
            ss << "mysql-server-" << serv << "-username";
            setEDBString( DBNAME, tostr(ss), user );
        }

        {
            fh_stringstream ss;
            ss << "mysql-server-" << serv << "-password";
            setEDBString( DBNAME, tostr(ss), pass );
        }
    }
    
};
