/******************************************************************************
*******************************************************************************
*******************************************************************************

    ferris ls
    Copyright (C) 2001 Ben Martin

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    For more details see the COPYING file in the root directory of this
    distribution.

    $Id: extoy.cpp,v 1.1 2006/12/07 07:03:31 ben Exp $

*******************************************************************************
*******************************************************************************
******************************************************************************/

#include <string>
#include <iostream>
#include <Ferris.hh>

using namespace std;
using namespace Ferris;


#define MAKESTATE   CodeState( __FILE__ ,  __LINE__ , __PRETTY_FUNCTION__ )

class CodeState
{
    string fileName;
    int    line;
    string functionName;

public:
    CodeState( const string& fi, int li, const string& fu )
        :
        fileName(fi),
        line(li),
        functionName(fu)
        {
        }

    inline const string& getFileName() const
        {
            return fileName;
        }

    inline const string& getFunctionName() const
        {
            return functionName;
        }

    inline int getLine() const
        {
            return line;
        }
    
    
};



class ex
{
    string name;
    CodeState State;
    
    
public:
    inline ex( const CodeState& state, const string& s)
        :
        name(s),
        State(state)
        {
        }


    const string what()
        {
            cerr << "what()" << endl;
            ostringstream ss;
            cerr << "what() fn:" << State.getFileName() << endl;
            ss << "ex. name:" << name
               << " fileName:" << State.getFileName()
               << " line:" << State.getLine()
               << " functionName:" << State.getFunctionName()
               ;
            cerr << "XX:" << tostr(ss);
            return tostr(ss);
        }
    
    
};

#define Throw_ex(x) throw ex(MAKESTATE, x)



// template <class X, class SUPER>
// class X : public SUPER
// {
// };



int main( int argc, const char** argv )
{
    try {
        
        Throw_ex("test1");
    }
    catch( ex& e )
    {
        cerr << "Cought an ex: " << e.what() << endl;
    }
    catch(...) {cerr << "!!!!!!!!! O K  !!!!!!!!!!\n\n\n";}
    
    return 0;
}
